/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Asal;
import com.portofolio.entity.vo.AsalId;

@Lazy
@Repository
public interface AsalDao extends CrudRepository<Asal, AsalId> {

	@Cacheable("AsalDaofindOneBy")
	Asal findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll + " and asal.namaAsal like %:namaAsal% and asal.kdAsalHead is null ")
	@Cacheable("AsalDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaAsal") String namaAsal,Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and asal.namaAsal like %:namaAsal% and asal.kdAsalHead=:kdAsalHead ")
	@Cacheable("AsalDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaAsal") String namaAsal,
			Pageable page, @Param("kdDepartemen") String kdDepartemen, @Param("kdAsalHead") Integer kdAsalHead);

	@Query(QListAll + " and asal.id.kode =:kode")
	@Cacheable("AsalDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAllDrop + " and  asal.kdAsalHead=:kdAsalHead ") 
	List<Map<String, Object>> findAllListDrop(@Param("kdProfile") Integer kdProfile, @Param("kdDepartemen") String kdDepartemen, @Param("kdAsalHead") Integer kdAsalHead);

	String QListAll = "select new map(asal.id.kdAsal as kdAsal,asal.id.kdProfile as kdProfile , asal.namaAsal as namaAsal "
			+ ",asal.reportsDisplay as reportsDisplay , asal.kdDepartemen as kdDepartemen "
			+ ",asal.kdAsalHead as kdAsalHead , asalHead.namaAsal as namaAsalHead "
			+ ",asal.kdJenisProfile as kdJenisProfile , asal.kodeExternal as kodeExternal "
			+ ",asal.namaExternal as namaExternal , asal.statusEnabled as statusEnabled "
			+ ",asal.noRec as noRec , departemen.namaDepartemen as namaDepartemen, asal.version as version )"
			+ " from Asal asal left join asal.id id "
			+ " left join Departemen departemen on asal.kdDepartemen=departemen.id.kode and asal.id.kdProfile=departemen.id.kdProfile"
			+ " left join Asal asalHead on asal.kdAsalHead=asalHead.id.kode and asal.id.kdProfile=asalHead.id.kdProfile "
			+ " where id.kdProfile=:kdProfile "
			+ " and departemen.id.kdProfile=id.kdProfile and asal.kdDepartemen =:kdDepartemen ";

	
	String QListAllDrop = "select new map(asal.id.kode as kode , asal.namaAsal as namaAsal )"
			+ " from Asal asal where asal.id.kdProfile=:kdProfile and asal.kdDepartemen =:kdDepartemen ";
	
	@Query(QfindAllList + " and asal.kdAsalHead =:kode ")
	List<Map<String, Object>> findAllAsal(@Param("kdProfile")Integer kdProfile,@Param("kode") Integer kode);

	String QfindAllList = "select new map(asal.namaAsal as namaAsal" + ", asal.id.kode as kdAsal)"
			+ " from Asal asal" + " where asal.id.kdProfile=:kdProfile" + " and asal.statusEnabled=true  ";


}
